import greenfoot.Greenfoot;
import greenfoot.GreenfootImage;
import greenfoot.GreenfootSound;
import java.awt.Color;

public class Alien
  extends Entity
{
  private GreenfootImage[] sprite = new GreenfootImage[3];
  private int score;
  private boolean isKilled = false;
  private boolean isShooting = false;
  private long lastFrameChange;
  private long frameDuration = 500L;
  public int x;
  public int y;
  public static String direction;
  public static boolean down;
  
  public Alien(Color color, GreenfootImage sprite1, GreenfootImage sprite2, GreenfootImage sprite3, int score)
  {
    super(color);
    this.sprite[0] = Sprite.paint(new GreenfootImage(sprite1), color);
    this.sprite[1] = Sprite.paint(new GreenfootImage(sprite2), color);
    this.sprite[2] = Sprite.paint(new GreenfootImage(sprite3), color);
    this.score = score;
    setImage(this.sprite[0]);
  }
  
  public void act()
  {
    if (!Game.isPause)
    {
      if (getY() >= 336) {
        ((Game)getWorld()).showGameOver();
      }
      if (!down) {
        if (direction.equals("LEFT")) {
          moveLeft();
        } else if (direction.equals("RIGHT")) {
          moveRight();
        }
      }
      setSprite(Game.delta);
      shoot();
    }
  }
  
  public void moveDownLeft()
  {
    setLocation(getX() - 1, getY() + 6);
  }
  
  public void moveDownRight()
  {
    setLocation(getX() + 1, getY() + 6);
  }
  
  private void setSprite(long delta)
  {
    this.lastFrameChange += delta;
    if (this.lastFrameChange > this.frameDuration)
    {
      this.lastFrameChange = 0L;
      if (this.isKilled)
      {
        ((Game)getWorld()).addScore(this.score);
        ((Game)getWorld()).alienShooted();
        ((Game)getWorld()).removeObject(this);
        return;
      }
      if (getImage() == this.sprite[0]) {
        setImage(this.sprite[1]);
      } else {
        setImage(this.sprite[0]);
      }
    }
  }
  
  public void shooted()
  {
    setImage(this.sprite[2]);
    this.isKilled = true;
    //((GreenfootSound)Game.cacheSnd.get("alien_dead")).play();
    GreenfootSound snd = new GreenfootSound("invaderkilled.wav");
    snd.setVolume(60);
    snd.play();
  }
  
  private void moveLeft()
  {
    if ((getX() >= 418) || (getX() > 90)) {
      setLocation(getX() - (int)(Game.delta * 68L / 1000L), getY());
    }
  }
  
  private void moveRight()
  {
    if ((getX() <= 90) || (getX() < 418)) {
      setLocation(getX() + (int)(Game.delta * 68L / 1000L), getY());
    }
  }
  
  private void moveDown()
  {
    setLocation(getX(), getY() + 6);
  }
  
  public static final Alien get(String name)
  {
    char[] txt = name.toCharArray();
    Color color = Common.WHITE;
    switch (txt[1])
    {
    case 'W': 
      color = Common.WHITE;
      break;
    case 'G': 
      color = Common.GREEN;
      break;
    case 'T': 
      color = Common.TEAL;
      break;
    case 'P': 
      color = Common.PURPLE;
      break;
    case 'Y': 
      color = Common.YELLOW;
      break;
    case 'R': 
      color = Common.RED;
    }
    if (txt[0] == '1') {
      return new Alien(color, (GreenfootImage)Game.cacheImg.get("enemy1_idle_0"), (GreenfootImage)Game.cacheImg.get("enemy1_idle_1"), (GreenfootImage)Game.cacheImg.get("enemy1_dead"), 10);
    }
    if (txt[0] == '2') {
      return new Alien(color, (GreenfootImage)Game.cacheImg.get("enemy2_idle_0"), (GreenfootImage)Game.cacheImg.get("enemy2_idle_1"), (GreenfootImage)Game.cacheImg.get("enemy2_dead"), 20);
    }
    if (txt[0] == '3') {
      return new Alien(color, (GreenfootImage)Game.cacheImg.get("enemy3_idle_0"), (GreenfootImage)Game.cacheImg.get("enemy3_idle_1"), (GreenfootImage)Game.cacheImg.get("enemy3_dead"), 40);
    }
    return null;
  }
  
  private void shoot()
  {
    if ((this.isShooting) && (!this.isKilled))
    {
      if (Greenfoot.getRandomNumber(25) < 1) {
        ((Game)getWorld()).addObject(new BulletEnemy(this.color), getX(), getY());
      }
      this.isShooting = false;
    }
    else if (Greenfoot.getRandomNumber(25) < 1)
    {
      this.isShooting = true;
    }
  }
}
