import greenfoot.GreenfootImage;
import greenfoot.GreenfootSound;
import java.awt.Color;

public class Bonus
  extends Entity
{
  private GreenfootImage[] sprite = new GreenfootImage[2];
  private boolean isMoveRight;
  private long lastFrameChange;
  private long frameDuration = 500L;
  private boolean isKilled = false;
  private int score;
  
  public static GreenfootSound snd = new GreenfootSound("ufo_highpitch.wav");
  
  public Bonus(Color color, int score, boolean move)
  {
    super(color);
    this.sprite[0] = Sprite.paint(new GreenfootImage((GreenfootImage)Game.cacheImg.get("bonus_idle")), color);
    this.sprite[1] = Sprite.paint(new GreenfootImage((GreenfootImage)Game.cacheImg.get("bonus_dead")), color);
    this.score = score;
    this.isMoveRight = move;
    setImage(this.sprite[0]);
    //((GreenfootSound)Game.cacheSnd.get("bonus")).playLoop();
    snd.setVolume(60);
    snd.playLoop();
  }
  
  public void act()
  {
    if (!Game.isPause)
    {
      this.lastFrameChange += Game.delta;
      if (this.lastFrameChange > this.frameDuration)
      {
        this.lastFrameChange = 0L;
        if (this.isKilled)
        {
          ((Game)getWorld()).addScore(this.score);
          ((Game)getWorld()).removeObject(this);
          //((GreenfootSound)Game.cacheSnd.get("bonus")).stop();
          snd.stop();
          return;
        }
      }
      if (!this.isKilled) {
        if (this.isMoveRight) {
          moveRight();
        } else {
          moveLeft();
        }
      }
    }
  }
  
  public void shooted()
  {
    setImage(this.sprite[1]);
    this.isKilled = true;
    //((GreenfootSound)Game.cacheSnd.get("alien_dead")).play();
    GreenfootSound snd_dead = new GreenfootSound("invaderkilled.wav");
    snd_dead.setVolume(60);
    snd_dead.play();
  }
  
  private void moveLeft()
  {
    if (getX() > 10)
    {
      setLocation(getX() - (int)(Game.delta * 68L / 1000L), getY());
    }
    else
    {
      ((Game)getWorld()).removeObject(this);
      //((GreenfootSound)Game.cacheSnd.get("bonus")).stop();
      snd.stop();
      return;
    }
  }
  
  private void moveRight()
  {
    if (getX() < 496)
    {
      setLocation(getX() + (int)(Game.delta * 68L / 1000L), getY());
    }
    else
    {
      ((Game)getWorld()).removeObject(this);
      //((GreenfootSound)Game.cacheSnd.get("bonus")).stop();
      snd.stop();
      return;
    }
  }
}
