import greenfoot.GreenfootImage;
import java.awt.Color;

public class BulletEnemy
  extends Entity
{
  private GreenfootImage[] sprite = new GreenfootImage[2];
  private long lastFrameChange;
  private long frameDuration = 1000L;
  
  public BulletEnemy(Color color)
  {
    super(color);
    this.sprite[0] = Sprite.paint(new GreenfootImage((GreenfootImage)Game.cacheImg.get("enemy_bullet_idle_0")), color);
    this.sprite[1] = Sprite.paint(new GreenfootImage((GreenfootImage)Game.cacheImg.get("enemy_bullet_idle_1")), color);
    setImage(this.sprite[0]);
  }
  
  public void act()
  {
    if (!Game.isPause)
    {
      if (getY() >= 340)
      {
        ((Game)getWorld()).removeObject(this);
        return;
      }
      if (getOneObjectAtOffset(0, 0, Base.class) != null)
      {
        Base b = (Base)getOneObjectAtOffset(0, 0, Base.class);
        if (Utils.collision(this, b))
        {
          ((Game)getWorld()).removeObject(this);
          b.shooted();
          return;
        }
      }
      if (getOneObjectAtOffset(0, 0, Ship.class) != null)
      {
        Ship s = (Ship)getOneObjectAtOffset(0, 0, Ship.class);
        if (Utils.collision(this, s))
        {
          ((Game)getWorld()).removeObject(this);
          s.shooted();
          
          return;
        }
      }
      setLocation(getX(), getY() + 2);
      setSprite(Game.delta);
    }
  }
  
  private void setSprite(long delta)
  {
    this.lastFrameChange += delta;
    if (this.lastFrameChange > this.frameDuration)
    {
      this.lastFrameChange = 0L;
      if (getImage() == this.sprite[0]) {
        setImage(this.sprite[1]);
      } else {
        setImage(this.sprite[0]);
      }
    }
  }
}
