import greenfoot.Actor;
import greenfoot.Greenfoot;
import greenfoot.GreenfootImage;

public class Button
  extends Actor
{
  private String state;
  private String text;
  private boolean mouseDown;
  private GreenfootImage[] sprite = new GreenfootImage[2];
  private boolean isSelected = false;
  private String button;
  private static long lastFrameChange;
  private static long frameDuration = 600L;
  private static boolean allowed = false;
  
  public Button(String text, String state)
  {
    this(text, state, "space");
  }
  
  public Button(String text, String state, String button)
  {
    this.state = state;
    this.text = text;
    this.button = button;
    this.mouseDown = false;
    this.sprite[0] = Font.drawString(text, Common.WHITE, "PressStart2P", 10.0F);
    this.sprite[1] = Font.drawString(text, Common.YELLOW, "PressStart2P", 10.0F);
    setImage(this.sprite[0]);
  }
  
  public void act()
  {
    if ((!allowed) && (this.isSelected))
    {
      lastFrameChange += Game.delta;
      if (lastFrameChange > frameDuration)
      {
        lastFrameChange = 0L;
        allowed = true;
      }
    }
    if (this.isSelected)
    {
      setImage(this.sprite[1]);
      if (allowed) {
        if (Greenfoot.isKeyDown(this.button))
        {
          allowed = false;
          ((Game)getWorld()).setState(this.state);
          ((Game)getWorld()).isChanged();
        }
      }
    }
    else
    {
      setImage(this.sprite[0]);
    }
  }
  
  public void selected(boolean is)
  {
    this.isSelected = is;
  }
}
