import greenfoot.GreenfootImage;
import java.awt.Color;
import java.awt.FontFormatException;
import java.io.IOException;
import java.io.PrintStream;

public class Font
{
  public static GreenfootImage drawString(String str, Color color, String font, float size)
  {
    int strLength = (str.length() + 2) * (int)size;
    GreenfootImage img = new GreenfootImage(strLength, (int)size);
    img.setColor(color);
    img.setFont(getFont(font, size));
    img.drawString(str, 0, (int)size);
    return img;
  }
  
  public static GreenfootImage drawString2(String str, Color color, String font, float size)
  {
    int strLength = (str.length() + 2) * (int)size;
    GreenfootImage img = new GreenfootImage(strLength, (int)size);
    img.setColor(Common.TEAL);
    img.fill();
    img.setColor(color);
    img.setFont(getFont(font, size));
    img.drawString(str, 0, (int)size);
    return img;
  }
  
  private static java.awt.Font getFont(String name, float size)
  {
    java.awt.Font font = null;
    try
    {
      java.awt.Font tmpFont = java.awt.Font.createFont(0, Font.class.getResourceAsStream("/fonts/" + name + ".TTF"));
      font = tmpFont.deriveFont(size);
    }
    catch (IOException e)
    {
      System.err.println(e.getMessage());
    }
    catch (FontFormatException e)
    {
      System.err.println(e.getMessage());
    }
    return font;
  }
}
