import greenfoot.Greenfoot;
import greenfoot.GreenfootImage;
import greenfoot.GreenfootSound;
import greenfoot.UserInfo;
import greenfoot.World;
import java.awt.Color;
import java.util.Iterator;
import java.util.List;

public class Game
  extends World
{
  public static final String VERSION = "0.2.1-Alpha";
  public static Cache<GreenfootImage> cacheImg = new Cache();
  private long lastLoopTime = Timer.getTime();
  private long lastFpsTime = 0L;
  private int fps;
  public static long delta;
  private String state = null;
  public static boolean isPause = false;
  private Text txtFps = new Text("FPS:00", Common.WHITE, "PressStart2P", 10.0F);
  private Text txtScore = new Text("SCORE: 0", Common.WHITE, "PressStart2P", 10.0F);
  private Text txtLives = new Text("Lives: 3", Common.WHITE, "PressStart2P", 10.0F);
  private Text txtLevelName = new Text("Start LEVEL00", Common.WHITE, "PressStart2P", 10.0F);
  private Text txtPressToStart = new Text("Press ENTER to start", Common.YELLOW, "PressStart2P", 12.0F);
  private Image imgFront;
  private Level level;
  private int score;
  private int lives;
  private int timerTxtLevelName = 0;
  private int timerBonus = 5;//Utils.random(10, 30, 15); // FIX
  private int bonusSpawnTimer = 15;
  private boolean newLevel = true;
  private int eCount = 0;
  private Sound sound = new Sound();
  
  public Game()
  {
    super(512, 450, 1);
    Utils.initImages();
    this.imgFront = new Image(new GreenfootImage((GreenfootImage)cacheImg.get("machine")));
    cleanScreen();
    
    showIntro();
    
    drawFront();
    this.mainMenu[0] = new Button("New game", "NEWGAME");
    this.mainMenu[1] = new Button("Highscore", "HIGHSCORE");
    this.mainMenu[2] = new Button("How to play", "HELP");
    this.mainMenu[3] = new Button("Credits", "CREDITS");
    this.ngMenu[0] = new Button("Classic", "GAME");
    this.ngMenu[1] = new Button("Hard", "GAME");
    this.ngMenu[2] = new Button("Crazy", "GAME");
    this.ngMenu[3] = new Button("Back to Main menu", "MAINMENU");
  }
  
  public int getLives()
  {
    return this.lives;
  }
  
  private boolean isChanged = false;
  private long menuLastFrameChange;
  
  public void isChanged()
  {
    this.isChanged = true;
  }
  
  public void act()
  {
    cleanFront();
    Timer.sleep(this.lastLoopTime + 10L - Timer.getTime());
    delta = Timer.getTime() - this.lastLoopTime;
    this.lastLoopTime = Timer.getTime();
    this.lastFpsTime += delta;
    this.fps += 1;
    if (!this.isChanged)
    {
      if (this.state.equals("MAINMENU"))
      {
        this.menuLastFrameChange += delta;
        if (this.menuLastFrameChange > this.menuFrameDuration)
        {
          this.menuLastFrameChange = 0L;
          int tmp = this.optMenu;
          if (Greenfoot.isKeyDown("up"))
          {
            tmp--;
            if (tmp == -1) {
              tmp = 3;
            }
          }
          else if (Greenfoot.isKeyDown("down"))
          {
            tmp++;
            if (tmp == 4) {
              tmp = 0;
            }
          }
          if (tmp != this.optMenu)
          {
            this.optMenu = tmp;
            this.mainMenu[0].selected(false);
            this.mainMenu[1].selected(false);
            this.mainMenu[2].selected(false);
            this.mainMenu[3].selected(false);
            this.mainMenu[tmp].selected(true);
          }
        }
      }
      else if (this.state.equals("NEWGAME"))
      {
        this.ngLastFrameChange += delta;
        if (this.ngLastFrameChange > this.ngFrameDuration)
        {
          this.ngLastFrameChange = 0L;
          int tmp = this.optNG;
          if (Greenfoot.isKeyDown("up"))
          {
            tmp--;
            if (tmp == -1) {
              tmp = 3;
            }
          }
          else if (Greenfoot.isKeyDown("down"))
          {
            tmp++;
            if (tmp == 4) {
              tmp = 0;
            }
          }
          if (tmp != this.optNG)
          {
            this.optNG = tmp;
            this.ngMenu[0].selected(false);
            this.ngMenu[1].selected(false);
            this.ngMenu[2].selected(false);
            this.ngMenu[3].selected(false);
            this.ngMenu[tmp].selected(true);
          }
        }
      }
      else if ((this.state.equals("GAME")) && (!isPause))
      {
        if (this.newLevel)
        {
          if (this.timerTxtLevelName >= 3)
          {
            removeObject(this.txtLevelName);
            this.timerTxtLevelName = 0;
            this.newLevel = false;
          }
          else if (this.lastFpsTime >= 1000L)
          {
            this.timerTxtLevelName += 1;
          }
        }
        else if (this.eCount == 0) {
          if (this.level.getNextLevelName().equals("END")) {
            showGameOver();
          } else {
            loadLevel(this.level.getNextLevelName());
          }
        }
        updateAlien();
        addBonus();
      }
    }
    else
    {
      if (this.state.equals("MAINMENU"))
      {
        cleanScreen();
        showMainMenu();
      }
      else if (this.state.equals("NEWGAME"))
      {
        cleanScreen();
        showNewGame();
      }
      else if (this.state.equals("GAME"))
      {
        cleanScreen();
        showGame();
      }
      else if (this.state.equals("HIGHSCORE"))
      {
        cleanScreen();
        showHighscore();
      }
      else if (this.state.equals("HELP"))
      {
        cleanScreen();
        showHowToPlay();
      }
      else if (this.state.equals("CREDITS"))
      {
        cleanScreen();
        showCredits();
      }
      this.isChanged = false;
    }
    if (this.lastFpsTime >= 1000L)
    {
      this.txtFps.setText("FPS:" + this.fps);
      this.txtFps.update();
      this.lastFpsTime = 0L;
      this.fps = 0;
    }
    drawFront();
  }
  
  private long menuFrameDuration = 50L;
  private long ngLastFrameChange;
  private long ngFrameDuration = 50L;
  
  public void started()
  {
    isPause = false;
    Timer.sleep(this.lastLoopTime + 10L - Timer.getTime());
    delta = Timer.getTime() - this.lastLoopTime;
    this.lastLoopTime = Timer.getTime();
    this.lastFpsTime += delta;
    this.fps += 1;
  }
  
  public void stopped()
  {
    isPause = true;
  }
  
  public void drawFront()
  {
    addObject(this.imgFront, 256, 225);
    addObject(this.txtFps, 116, 438);
    addObject(this.sound, 80, 46);
  }
  
  public void cleanFront()
  {
    removeObject(this.imgFront);
    removeObject(this.txtFps);
    removeObject(this.sound);
  }
  
  public void cleanScreen()
  {
    removeObjects(getObjects(null));
    setBackground((GreenfootImage)cacheImg.get("background"));
  }
  
  public void setState(String state)
  {
    this.state = state;
  }
  
  public void showGame()
  {
    this.state = "GAME";
    loadLevel("LEVEL01");
    initDifficulty(this.optNG);
    addObject(new Ship(), 254, 341);
    addObject(new Line(), 255, 348);
    addObject(this.txtLives, 142, 360);
    addObject(this.txtScore, 310, 360);
    addObject(this.txtLevelName, 256, 225);
  }
  
  public void showIntro()
  {
    this.state = "INTRO";
    addObject(new Text(".", Common.WHITE, "INVADERS", 140.0F), 323, 182);
    Button pressStart = new Button("Press ENTER to start", "MAINMENU", "enter");
    pressStart.selected(true);
    
    addObject(pressStart, 272, 289);
    addObject(new Text("Version: " + VERSION, Common.WHITE, "PressStart2P", 8.0F), 266, 353);
  }
  
  private Button[] mainMenu = new Button[4];
  private int optMenu;
  
  public void showMainMenu()
  {
    this.state = "MAINMENU";
    this.optMenu = 0;
    this.mainMenu[0].selected(true);
    this.mainMenu[1].selected(false);
    this.mainMenu[2].selected(false);
    this.mainMenu[3].selected(false);
    addObject(new Text(".", Common.WHITE, "INVADERS", 90.0F), 300, 146);
    addObject(this.mainMenu[0], 266, 216);
    addObject(this.mainMenu[1], 266, 246);
    addObject(this.mainMenu[2], 266, 276);
    addObject(this.mainMenu[3], 266, 306);
    addObject(new Text("Version: " + VERSION, Common.WHITE, "PressStart2P", 8.0F), 266, 353);
  }
  
  private Button[] ngMenu = new Button[4];
  private int optNG;
  
  public void showNewGame()
  {
    this.state = "NEWGAME";
    this.optNG = 0;
    this.ngMenu[0].selected(true);
    this.ngMenu[1].selected(false);
    this.ngMenu[2].selected(false);
    this.ngMenu[3].selected(false);
    addObject(new Text(".", Common.WHITE, "INVADERS", 90.0F), 300, 146);
    addObject(new Text("Choose difficulty:", Common.WHITE, "PressStart2P", 10.0F), 266, 216);
    addObject(this.ngMenu[0], 266, 246);
    addObject(this.ngMenu[1], 266, 276);
    addObject(this.ngMenu[2], 266, 306);
    addObject(this.ngMenu[3], 266, 336);
    addObject(new Text("Version: " + VERSION, Common.WHITE, "PressStart2P", 8.0F), 266, 353);
  }
  
  public void showHighscore()
  {
    this.state = "HIGHSCORE";
    addObject(new Text(".", Common.WHITE, "INVADERS", 90.0F), 300, 146);
    addObject(new Text("Highscore:", Common.WHITE, "PressStart2P", 10.0F), 266, 203);
    
    List<UserInfo> hiscore = Highscore.getTop();
    for (int i = 0; i < 6; i++)
    {
      UserInfo user = (UserInfo)hiscore.get(i);
      addObject(new Text(i + 1 + ". " + user.getUserName() + " " + user.getScore(), Common.WHITE, "PressStart2P", 10.0F), 266, 223 + i * 20);
    }
    addObject(new Text("Version: " + VERSION, Common.WHITE, "PressStart2P", 8.0F), 266, 353);
    Button back = new Button("Press SPACE to go back", "MAINMENU");
    back.selected(true);
    addObject(back, 272, 340);
  }
  
  public void showHowToPlay()
  {
    this.state = "HOWTOPLAY";
    Button back = new Button("Press SPACE to go back", "MAINMENU");
    back.selected(true);
    addObject(back, 272, 359);
  }
  
  public void showCredits()
  {
    this.state = "CREDITS";
    addObject(new Text(".", Common.WHITE, "INVADERS", 90.0F), 300, 146);
    addObject(new Text("Game developed by Lollygag.", Common.WHITE, "PressStart2P", 8.0F), 263, 202);
    addObject(new Text("Game inspirated by original Space Invaders", Common.WHITE, "PressStart2P", 8.0F), 263, 222);
    addObject(new Text("developed by Tatio Corporation.", Common.WHITE, "PressStart2P", 8.0F), 263, 232);
    addObject(new Text("Sprites:", Common.WHITE, "PressStart2P", 8.0F), 263, 245);
    addObject(new Text("Copyright 2014 by Lollygag", Common.WHITE, "PressStart2P", 8.0F), 263, 255);
    addObject(new Text("Sounds:", Common.WHITE, "PressStart2P", 8.0F), 263, 268);
    addObject(new Text("Copyright 1978 by Taito Corporation", Common.WHITE, "PressStart2P", 8.0F), 263, 278);
    addObject(new Text("Backgorund sprite:", Common.WHITE, "PressStart2P", 8.0F), 263, 291);
    addObject(new Text("Copyright 1999 by NINTENDO", Common.WHITE, "PressStart2P", 8.0F), 263, 301);
    addObject(new Text("Font 'Invaders':", Common.WHITE, "PressStart2P", 8.0F), 263, 314);
    addObject(new Text("Copyright 2000 by dustBUST fonts", Common.WHITE, "PressStart2P", 8.0F), 263, 324);
    addObject(new Text("Font 'PressStart2P':", Common.WHITE, "PressStart2P", 8.0F), 263, 337);
    addObject(new Text("Copyright 2011 by Cody Boisclair", Common.WHITE, "PressStart2P", 8.0F), 263, 347);
    Button back = new Button("Press SPACE to go back", "MAINMENU");
    back.selected(true);
    addObject(back, 272, 359);
  }
  
  public void showGameOver()
  {
    this.state = "GAMEOVER";
    
    //Bonus sound fix
    Bonus.snd.stop();
    
    cleanScreen();
    
    addObject(new Text(".", Common.WHITE, "INVADERS", 140.0F), 323, 182);
    addObject(new Text("Score: " + this.score, Common.GREEN, "PressStart2P", 16.0F), 255, 290);
    
    Highscore.add(this.score);
    
    Button pressEnter = new Button("Press ENTER to go to menu", "MAINMENU", "enter");
    pressEnter.selected(true);
    addObject(pressEnter, 272, 341);
    drawFront();
    this.lives = 3;
    this.score = 0;
    this.eCount = 0;
    this.txtLives.setText("Lives: " + this.lives);
    this.txtLives.update();
    this.txtScore.setText("Score: " + this.score);
    this.txtScore.update();
  }
  
  public void loadLevel(String levelname)
  {
    removeObjects(getObjects(Alien.class));
    removeObjects(getObjects(BulletEnemy.class));
    
    removeObjects(getObjects(BulletPlayer.class));
    this.newLevel = true;
    Alien.direction = "RIGHT";
    Alien.down = false;
    this.level = new Level(levelname);
    this.txtLevelName.setText("Start " + levelname);
    this.txtLevelName.update();
    List aliens = Utils.initAliens(this.level.getEnemies(), this.level.getX(), this.level.getY(), this.level.getEndX(), this.level.getEndY());
    Iterator i = aliens.iterator();
    while (i.hasNext())
    {
      Alien e = (Alien)i.next();
      addObject(e, e.x, e.y);
      this.eCount += 1;
    }
    addObject(this.txtLevelName, 256, 225);
  }
  
  public void addBonus()
  {
    //System.out.println(bonusSpawnTimer);
    if (this.lastFpsTime >= 1000L) {
      this.timerBonus += 1;
    }
    if (this.timerBonus == this.bonusSpawnTimer)
    {
      this.timerBonus = 0;
      this.bonusSpawnTimer = Utils.random(10, 30, this.bonusSpawnTimer);
      int i = Greenfoot.getRandomNumber(5);
      Color color = Common.WHITE;
      if (i == 0) {
        color = Common.RED;
      } else if (i == 1) {
        color = Common.PURPLE;
      } else if (i == 2) {
        color = Common.GREEN;
      } else if (i == 3) {
        color = Common.TEAL;
      } else if (i == 4) {
        color = Common.YELLOW;
      }
      i = Greenfoot.getRandomNumber(3);
      int score = 50;
      if (i == 0) {
        score = 100;
      } else if (i == 1) {
        score = 150;
      } else if (i == 2) {
        score = 200;
      }
      if (Greenfoot.getRandomNumber(25) % 2 == 0) {
        addObject(new Bonus(color, score, true), 57, 103);
      } else {
        addObject(new Bonus(color, score, false), 468, 103);
      }
    }
  }
  
  public void updateAlien()
  {
    if (Alien.direction.equals("RIGHT"))
    {
      int right = Utils.checkEnemyPositionRight(getObjects(Alien.class));
      if (right >= 418)
      {
        Alien.down = true;
        List<Alien> aliens = getObjects(Alien.class);
        for (Alien a : aliens) {
          a.moveDownLeft();
        }
        Alien.down = false;
        Alien.direction = "LEFT";
      }
    }
    else if (Alien.direction.equals("LEFT"))
    {
      int left = Utils.checkEnemyPositionLeft(getObjects(Alien.class));
      if (left <= 90)
      {
        Alien.down = true;
        List<Alien> aliens = getObjects(Alien.class);
        for (Alien a : aliens) {
          a.moveDownRight();
        }
        Alien.down = false;
        Alien.direction = "RIGHT";
      }
    }
  }
  
  public void initDifficulty(int i)
  {
    if (i == 0)
    {
      this.lives = 3;
      for (Base b : Utils.createBase(Common.GREEN, 132, 310)) {
        addObject(b, b.x, b.y);
      }
      for (Base b : Utils.createBase(Common.GREEN, 242, 310)) {
        addObject(b, b.x, b.y);
      }
      for (Base b : Utils.createBase(Common.GREEN, 352, 310)) {
        addObject(b, b.x, b.y);
      }
    }
    else if (i == 1)
    {
      this.lives = 3;
    }
    else if (i == 2)
    {
      this.lives = 1;
    }
    this.score = 0;
    this.txtLives.setText("Lives: " + this.lives);
    this.txtLives.update();
    this.txtScore.setText("Score: " + this.score);
    this.txtScore.update();
  }
  
  public void shipShooted()
  {
    this.lives -= 1;
    this.txtLives.setText("Lives: " + this.lives);
    this.txtLives.update();
    if (this.lives == 0) {
      showGameOver();
    }
  }
  
  public void alienShooted()
  {
    this.eCount -= 1;
  }
  
  public void addScore(int s)
  {
    this.score += s;
    this.txtScore.setText("SCORE: " + this.score);
    this.txtScore.update();
  }
}
