import greenfoot.Greenfoot;
import greenfoot.GreenfootImage;
import greenfoot.GreenfootSound;

public class Ship
  extends Entity
{
  private GreenfootImage[] sprite = new GreenfootImage[3];
  private boolean isKilled = false;
  private long lastFrameChange;
  private long frameDuration = 250L;
  
  public Ship()
  {
    super(Common.GREEN);
    this.sprite[0] = Sprite.paint((GreenfootImage)Game.cacheImg.get("player"), this.color);
    this.sprite[1] = Sprite.paint((GreenfootImage)Game.cacheImg.get("player_dead_0"), this.color);
    this.sprite[2] = Sprite.paint((GreenfootImage)Game.cacheImg.get("player_dead_1"), this.color);
    setImage(this.sprite[0]);
  }
  
  public void shooted()
  {
    ((Game)getWorld()).shipShooted();
    //((GreenfootSound)Game.cacheSnd.get("player_dead")).play();
    GreenfootSound snd = new GreenfootSound("explosion.wav");
    snd.setVolume(60);
    snd.play();
    setImage(this.sprite[2]);
    this.isKilled = true;
    this.lastFrameChange = 0L;
  }
  
  public void act()
  {
    if (!Game.isPause) {
      if (!this.isKilled)
      {
        if ((getX() <= 90) || (getX() < 418)) {
          if (Greenfoot.isKeyDown("right")) {
            setLocation(getX() + 2, getY());
          }
        }
        if ((getX() >= 418) || (getX() > 90)) {
          if (Greenfoot.isKeyDown("left")) {
            setLocation(getX() - 2, getY());
          }
        }
        if (Greenfoot.isKeyDown("space"))
        {
          this.lastFrameChange += Game.delta;
          if (this.lastFrameChange > this.frameDuration)
          {
            this.lastFrameChange = 0L;
            ((Game)getWorld()).addObject(new BulletPlayer(), getX(), getY() - 7);
          }
        }
      }
      else
      {
        if (getImage() == this.sprite[2]) {
          setImage(this.sprite[1]);
        } else {
          setImage(this.sprite[2]);
        }
        this.lastFrameChange += Game.delta;
        if (this.lastFrameChange > this.frameDuration)
        {
          this.lastFrameChange = 0L;
          setImage(this.sprite[0]);
          this.isKilled = false;
        }
      }
    }
  }
}
