import greenfoot.GreenfootImage;
import java.awt.Color;

public class Sprite
{
  public static GreenfootImage paint(GreenfootImage img, Color color)
  {
    for (int x = 0; x < img.getWidth(); x++) {
      for (int y = 0; y < img.getHeight(); y++)
      {
        Color originalColor = img.getColorAt(x, y);
        if (originalColor.getAlpha() == 255) {
          img.setColorAt(x, y, color);
        }
      }
    }
    return img;
  }
  
  public static GreenfootImage scale(GreenfootImage img, float size)
  {
    img.scale((int)(img.getWidth() * size), (int)(img.getHeight() * size));
    return img;
  }
  
  public static GreenfootImage getSprite(GreenfootImage img, int id, int width, int height)
  {
    int y = 0;
    int rowSize = img.getWidth() / width;
    int x = id % rowSize * width;
    y = (id - id % rowSize) / rowSize * height;
    return getSprite(img, x, y, x + width, y + height, width, height);
  }
  
  public static GreenfootImage getSprite(GreenfootImage img, int x, int y, int z, int w, int width, int height)
  {
    int tmpHeight;
    int tmpWidth;
    if (x < z) {
      tmpWidth = z - x;
    } else {
      tmpWidth = x - z;
    }

    if (y < w) {
      tmpHeight = w - y;
    } else {
      tmpHeight = y - w;
    }
    GreenfootImage tmpImg = new GreenfootImage(tmpWidth, tmpHeight);
    if (x < z) {
      for (int j = x; j < z; j++) {
        if (y < w) {
          for (int i = y; i < w; i++) {
            if ((j >= 0) && (j < img.getWidth()) && (i >= 0) && (i < img.getHeight())) {
              tmpImg.setColorAt(tmpWidth - (z - j), tmpHeight - (w - i), img.getColorAt(j, i));
            }
          }
        } else {
          for (int i = w; i < y; i++) {
            tmpImg.setColorAt(tmpWidth - (z - j), tmpHeight - (y - i), img.getColorAt(j, i));
          }
        }
      }
    } else {
      for (int j = z; j < x; j++) {
        if (y < w) {
          for (int i = y; i < w; i++) {
            tmpImg.setColorAt(tmpWidth - (x - j), tmpHeight - (w - i), img.getColorAt(j, i));
          }
        } else {
          for (int i = w; i < y; i++) {
            tmpImg.setColorAt(tmpWidth - (x - j), tmpHeight - (y - i), img.getColorAt(j, i));
          }
        }
      }
    }
    tmpImg.scale(width, height);
    return tmpImg;
  }
}
