import greenfoot.GreenfootImage;
import greenfoot.GreenfootSound;
import greenfoot.Greenfoot;
import java.awt.Color;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Utils
{
  public static final void initImages()
  {
    Game.cacheImg.put("background", new GreenfootImage("Background.png"));
    GreenfootImage tmp = new GreenfootImage("Base.png");
    Game.cacheImg.put("base_tr_0", Sprite.getSprite(tmp, 0, 4, 4));
    Game.cacheImg.put("base_tr_1", Sprite.getSprite(tmp, 1, 4, 4));
    Game.cacheImg.put("base_tr_2", Sprite.getSprite(tmp, 2, 4, 4));
    Game.cacheImg.put("base_tl_0", Sprite.getSprite(tmp, 3, 4, 4));
    Game.cacheImg.put("base_tl_1", Sprite.getSprite(tmp, 4, 4, 4));
    Game.cacheImg.put("base_tl_2", Sprite.getSprite(tmp, 5, 4, 4));
    Game.cacheImg.put("base_bl_0", Sprite.getSprite(tmp, 6, 4, 4));
    Game.cacheImg.put("base_bl_1", Sprite.getSprite(tmp, 7, 4, 4));
    Game.cacheImg.put("base_bl_2", Sprite.getSprite(tmp, 8, 4, 4));
    Game.cacheImg.put("base_br_0", Sprite.getSprite(tmp, 9, 4, 4));
    Game.cacheImg.put("base_br_1", Sprite.getSprite(tmp, 10, 4, 4));
    Game.cacheImg.put("base_br_2", Sprite.getSprite(tmp, 11, 4, 4));
    Game.cacheImg.put("base_m_0", Sprite.getSprite(tmp, 12, 4, 4));
    Game.cacheImg.put("base_m_1", Sprite.getSprite(tmp, 13, 4, 4));
    Game.cacheImg.put("base_m_2", Sprite.getSprite(tmp, 14, 4, 4));
    tmp = new GreenfootImage("Bonus.png");
    Game.cacheImg.put("bonus_idle", Sprite.scale(Sprite.getSprite(tmp, 0, 16, 8), 1.5F));
    Game.cacheImg.put("bonus_dead", Sprite.scale(Sprite.getSprite(tmp, 1, 16, 8), 1.5F));
    Game.cacheImg.put("background", new GreenfootImage("Background.png"));
    tmp = new GreenfootImage("Enemy1.png");
    Game.cacheImg.put("enemy1_idle_0", Sprite.scale(Sprite.getSprite(tmp, 0, 12, 12), 1.5F));
    Game.cacheImg.put("enemy1_idle_1", Sprite.scale(Sprite.getSprite(tmp, 1, 12, 12), 1.5F));
    Game.cacheImg.put("enemy1_dead", Sprite.scale(Sprite.getSprite(tmp, 2, 12, 12), 1.5F));
    tmp = new GreenfootImage("Enemy2.png");
    Game.cacheImg.put("enemy2_idle_0", Sprite.scale(Sprite.getSprite(tmp, 0, 12, 12), 1.5F));
    Game.cacheImg.put("enemy2_idle_1", Sprite.scale(Sprite.getSprite(tmp, 1, 12, 12), 1.5F));
    Game.cacheImg.put("enemy2_dead", Sprite.scale(Sprite.getSprite(tmp, 2, 12, 12), 1.5F));
    tmp = new GreenfootImage("Enemy3.png");
    Game.cacheImg.put("enemy3_idle_0", Sprite.scale(Sprite.getSprite(tmp, 0, 12, 12), 1.5F));
    Game.cacheImg.put("enemy3_idle_1", Sprite.scale(Sprite.getSprite(tmp, 1, 12, 12), 1.5F));
    Game.cacheImg.put("enemy3_dead", Sprite.scale(Sprite.getSprite(tmp, 2, 12, 12), 1.5F));
    tmp = new GreenfootImage("EnemyBullet.png");
    Game.cacheImg.put("enemy_bullet_idle_0", Sprite.getSprite(tmp, 0, 4, 8));
    Game.cacheImg.put("enemy_bullet_idle_1", Sprite.getSprite(tmp, 1, 4, 8));
    Game.cacheImg.put("machine", Sprite.scale(new GreenfootImage("Machine.png"), 2.0F));
    Game.cacheImg.put("player", Sprite.scale(new GreenfootImage("Player.png"), 1.5F));
    Game.cacheImg.put("player_bullet_idle", Sprite.scale(new GreenfootImage("PlayerBullet.png"), 1.5F));
    tmp = new GreenfootImage("PlayerDead.png");
    Game.cacheImg.put("player_dead_0", Sprite.scale(Sprite.getSprite(tmp, 0, 16, 8), 1.5F));
    Game.cacheImg.put("player_dead_1", Sprite.scale(Sprite.getSprite(tmp, 1, 16, 8), 1.5F));
  }
  
  public static final boolean collision(Entity a, Entity b)
  {
    if (b.getImage().getWidth() * b.getImage().getHeight() > a.getImage().getHeight() * a.getImage().getWidth())
    {
      Entity tmp = b;
      b = a;
      a = b;
    }
    int hypot = (int)Math.hypot(b.getImage().getWidth(), b.getImage().getHeight());
    GreenfootImage imgA = new GreenfootImage(hypot, hypot);
    imgA.drawImage(b.getImage(), hypot / 2 - b.getImage().getWidth() / 2, hypot / 2 - b.getImage().getHeight() / 2);
    imgA.rotate(b.getRotation());
    int w = hypot;
    GreenfootImage tmp = a.getImage();
    GreenfootImage imgB = new GreenfootImage(hypot = (int)Math.hypot(tmp.getWidth(), tmp.getHeight()), hypot);
    imgB.drawImage(tmp, imgB.getWidth() / 2 - tmp.getWidth() / 2, imgB.getHeight() / 2 - tmp.getHeight() / 2);
    imgB.rotate(a.getRotation());
    int xOffset = a.getX() - b.getX() - (imgB.getWidth() / 2 - w / 2);
    int yOffset = a.getY() - b.getY() - (imgB.getHeight() / 2 - w / 2);
    boolean result = true;
    for (int y = Math.max(0, yOffset); (y < w) && (y < hypot + yOffset) && (result); y++) {
      for (int x = Math.max(0, xOffset); (x < w) && (x < hypot + xOffset) && (result); x++) {
        if ((imgB.getColorAt(x - xOffset, y - yOffset).getAlpha() > 0) && (imgA.getColorAt(x, y).getAlpha() > 0)) {
          result = false;
        }
      }
    }
    return !result;
  }
  
  public static Base[] createBase(Color color, int x, int y)
  {
    Base[] result = new Base[20];

    result[0] = Base.TL(color);
    result[0].setPosition(x, y);
    result[1] = Base.M(color);
    result[1].setPosition(x + 4, y);
    result[2] = Base.M(color);
    result[2].setPosition(x + 8, y);
    result[3] = Base.M(color);
    result[3].setPosition(x + 12, y);
    result[4] = Base.M(color);
    result[4].setPosition(x + 16, y);
    result[5] = Base.M(color);
    result[5].setPosition(x + 20, y);
    result[6] = Base.TR(color);
    result[6].setPosition(x + 24, y);
    result[7] = Base.M(color);
    result[7].setPosition(x, y + 4);
    result[8] = Base.M(color);
    result[8].setPosition(x + 4, y + 4);
    result[9] = Base.M(color);
    result[9].setPosition(x + 8, y + 4);
    result[10] = Base.M(color);
    result[10].setPosition(x + 12, y + 4);
    result[11] = Base.M(color);
    result[11].setPosition(x + 16, y + 4);
    result[12] = Base.M(color);
    result[12].setPosition(x + 20, y + 4);
    result[13] = Base.M(color);
    result[13].setPosition(x + 24, y + 4);
    
    result[14] = Base.M(color);
    result[14].setPosition(x, y + 8);
    result[15] = Base.BL(color);
    result[15].setPosition(x + 4, y + 8);
    result[16] = Base.BR(color);
    result[16].setPosition(x + 20, y + 8);
    result[17] = Base.M(color);
    result[17].setPosition(x + 24, y + 8);
    
    result[18] = Base.M(color);
    result[18].setPosition(x, y + 12);
    result[19] = Base.M(color);
    result[19].setPosition(x + 24, y + 12);
    return result;
  }
  
  public static int checkEnemyPositionLeft(List enemies)
  {
    int temp = 418;
    Iterator i = enemies.iterator();
    while (i.hasNext())
    {
      Alien e = (Alien)i.next();
      if (temp > e.getX()) {
        temp = e.getX();
      }
    }
    return temp;
  }
  
  public static int checkEnemyPositionRight(List enemies)
  {
    int temp = 90;
    Iterator i = enemies.iterator();
    while (i.hasNext())
    {
      Alien e = (Alien)i.next();
      if (temp < e.getX()) {
        temp = e.getX();
      }
    }
    return temp;
  }
  
  public static ArrayList initAliens(String[] enemies, int startX, int startY, int endX, int endY)
  {
    ArrayList aliens = new ArrayList();
    for (int row = 0; row < endY; row++) {
      for (int id = row * endX; id < endX + endX * row; id++) {
        if (!enemies[id].equals("0"))
        {
          Alien a = Alien.get(enemies[id]);
          a.x = (startX + 24 * (id % endX));
          a.y = (startY + 18 * row);
          aliens.add(a);
        }
      }
    }
    return aliens;
  }
  
  public static int random(int min, int max, int last)
  {
      int rand = 0;
      while ((rand < min) || (rand > max) || (rand == last))
        rand = Greenfoot.getRandomNumber(max);
      return rand;
  }
}
